/*
SUSIE32 '00AM' Plug-in for LZH(LH0̂)
*/

#include <windows.h>
#include "spi00am.h"
#include "spi00am_ex.h"
#include "infcache.h"
#include "common.h"

//O[oϐ
InfoCache infocache; //A[JCuLbVNX

//---------------------------------------------------------------------------
/* Gg|Cg */
BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	llog("DllMain");
	switch (ul_reason_for_call) {
		case DLL_PROCESS_DETACH:
			infocache.Clear();
			break;
	}
	return SpiEntryPoint(hModule, ul_reason_for_call, lpReserved);
}

/***************************************************************************
 * SPI֐
 ***************************************************************************/
//---------------------------------------------------------------------------
int __stdcall GetPluginInfo(int infono, LPSTR buf, int buflen)
{
	llog("GetPluginInfo");
	if (infono < 0 || infono >= (sizeof(pluginfo) / sizeof(char *))) 
		return 0;

	lstrcpyn(buf, pluginfo[infono], buflen);

	return lstrlen(buf);
}
//---------------------------------------------------------------------------
int __stdcall IsSupported(LPSTR filename, DWORD dw)
{
	char *data;
	char buff[HEADBUF_SIZE];

	char buf[128];
	BYTE *d =(BYTE*)dw;
	sprintf(buf, "IsSupported:%x:%x,%x,%x,%x", dw, d[0], d[1], d[2], d[3]);
	llog(buf);
	if ((dw & 0xFFFF0000) == 0) {
	/* dw̓t@Cnh */
		DWORD ReadBytes;
		if (!ReadFile((HANDLE)dw, buff, HEADBUF_SIZE, &ReadBytes, NULL)) {
			return 0;
		}
		data = buff;
		llog("FileHandle");
	} else {
	/* dw̓obt@ւ̃|C^ */
		data = (char *)dw;
		llog("Buffer");
	}

	/* tH[}bgmF */
	if (IsSupportedEx(filename, data)) return 1;

	return 0;
}
//---------------------------------------------------------------------------
//A[JCuLbV
int GetArchiveInfoCache(char *filename, long len, HLOCAL *phinfo, fileInfo *pinfo)
{
	int ret = infocache.Dupli(filename, phinfo, pinfo);
	if (ret != SPI_NO_FUNCTION) return ret;

	//LbVɖ
	HLOCAL hinfo;
	HANDLE hf;
	char headbuf[HEADBUF_SIZE];
	DWORD ReadBytes;

	hf = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	if (hf == INVALID_HANDLE_VALUE) return SPI_FILE_READ_ERROR;
	if (SetFilePointer(hf, len, NULL, FILE_BEGIN) != (DWORD)len) {
		CloseHandle(hf);
		return SPI_FILE_READ_ERROR;
	}
	if (!ReadFile(hf, headbuf, HEADBUF_SIZE, &ReadBytes, NULL)) {
		CloseHandle(hf);
		return SPI_FILE_READ_ERROR;
	}
	CloseHandle(hf);
	if (ReadBytes != HEADBUF_SIZE) return SPI_NOT_SUPPORT;
	if (!IsSupportedEx(filename, headbuf)) return SPI_NOT_SUPPORT;
	
	ret = GetArchiveInfoEx(filename, len, &hinfo);
	if (ret != SPI_ALL_RIGHT) return ret;

	//LbV
	infocache.Add(filename, &hinfo);

if (phinfo != NULL) {
	UINT size = LocalSize(hinfo);
	/* o͗p̃̊蓖 */
	*phinfo = LocalAlloc(LMEM_FIXED, size);
	if (*phinfo == NULL) {
		return SPI_NO_MEMORY;
	}

	memcpy(*phinfo, (void*)hinfo, size);
} else {
	fileInfo *ptmp = (fileInfo *)hinfo;
	if (pinfo->filename[0] != '\0') {
		for (;;) {
			if (ptmp->method[0] == '\0') return SPI_NO_FUNCTION;
			if (lstrcmpi(ptmp->filename, pinfo->filename) == 0) break;
			ptmp++;
		}
	} else {
		for (;;) {
			if (ptmp->method[0] == '\0') return SPI_NO_FUNCTION;
			if (ptmp->position == pinfo->position) break;
			ptmp++;
		}
	}
	*pinfo = *ptmp;
}
	return SPI_ALL_RIGHT;
}
//---------------------------------------------------------------------------
int __stdcall GetArchiveInfo(LPSTR buf, long len, unsigned int flag, HLOCAL *lphInf)
{
	llog("GetArchiveInfo");
	//͂ɂ͑ΉȂ
	if ((flag & 7) != 0) return SPI_NO_FUNCTION;

	*lphInf = NULL;
	return GetArchiveInfoCache(buf, len, lphInf, NULL);
}
//---------------------------------------------------------------------------
int __stdcall GetFileInfo
(LPSTR buf, long len, LPSTR filename, unsigned int flag, struct fileInfo *lpInfo)
{
	//͂ɂ͑ΉȂ
	if ((flag & 7) != 0) return SPI_NO_FUNCTION;

	lstrcpy(lpInfo->filename, filename);

	return GetArchiveInfoCache(buf, len, NULL, lpInfo);
}
//---------------------------------------------------------------------------
int __stdcall GetFile(LPSTR src, long len,
			   LPSTR dest, unsigned int flag,
			   SPI_PROGRESS lpPrgressCallback, long lData)
{
	//t@Cւ̏o͂͑ΉĂȂ
	if ((flag & 0x700) == 0) return SPI_NO_FUNCTION;
	//͂ɂ͑ΉȂ
	if ((flag & 7) != 0) return SPI_NO_FUNCTION;

	fileInfo info;
	info.filename[0] = '\0';
	info.position = len;
	int ret = GetArchiveInfoCache(src, 0, NULL, &info);
	if (ret != SPI_ALL_RIGHT) return ret;

	return GetFileEx(src, (HLOCAL *)dest, &info, lpPrgressCallback, lData);
}
//---------------------------------------------------------------------------

